/*
 * CRungeKutt.java
 *
 * Created on tvrtok, 2004, december 9, 23:25
 */

/**
 *
 * @author  HiHi
 */
abstract public class m_JRungeKutt {
    
    /** Creates a new instance of CRungeKutt */
    public m_JRungeKutt() {
        k1=k2=k3=k4=m1=m2=m3=m4=y=z=x=maxim=h=0;
    }
    
    public abstract double f(double x, double y,double z);
    
    public abstract double g(double x, double y,double z);
    
    public void setStep(double step){
        h = step;
    }
    public void setInputValues(double x0, double y0, double z0){
        x=x0;
        y=y0;
        z=z0;
    }
    
   public double[] getStep(){
         k1 = h * f(x, y, z);
         m1 = h * g(x, y, z);
         k2 = h * f(x + h/(double)2, y + k1/(double)2,z + m1/(double)2);
         m2 = h * g(x + h/(double)2, y + k1/(double)2,z + m1/(double)2);
         k3 = h * f(x + h/(double)2, y + k2/(double)2,z + m2/(double)2);
         m3 = h * g(x + h/(double)2, y + k2/(double)2,z + m1/(double)2);
         k4 = h * f(x + h, y + k3,z + m3);
         m4 = h * g(x + h, y + k3,z + m3);
         y += (k1 + 2*k2 + 2*k3 + k4)/(double)6;
         z += (m1 + 2*m2 + 2*m3 + m4)/(double)6;
         x += h;
         double t[]={x,y,z};
         return t;
    }
    public double[] Result() {
        double t[]={0.0,0.0,0.0,0.0};
        while(t[2] < maxim){
          t=getStep();
          t[3]++;
        }
       return t;
    }
   
    private double k1, k2, k3, k4, m1, m2, m3, m4, y, z, x, maxim, h;
    private int iter,t0;
}
