/*
 * m_JGraph.java
 *
 * Created on Utorok, 2005, janur 18, 3:25
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.*;
/**
 *
 * @author  X-so
 */
public class m_JVGraph extends m_JGraph {
    //private m_JPoint PHPoint;
    private m_JPoint EQPoint;
    double p[];
    m_JLV m_lv;
    private CPHPointsArray PHPointsArray;
    
    
    /** Creates a new instance of m_JGraph */
    
    private class CPHPointsArray {
        private m_JPoint PHPoints[];
        private Color Colors[];
        public int ActualIndex;
        private final int MaxIndex=20;  
        
        public CPHPointsArray() {
            PHPoints = null;
            Colors = null;
            ActualIndex = 0;
        }
        public void AddStartConditions(m_JPoint newPHPoint){
        if ( ActualIndex == 0 ) {
             ActualIndex++;
             PHPoints = new m_JPoint[ActualIndex];
             Colors = new Color[ActualIndex];
             int c = GetRand();
             Colors[ActualIndex - 1] = new Color(0,c,0);
             PHPoints[ActualIndex-1] = new m_JPoint(newPHPoint);
        }else
            if ( ActualIndex < MaxIndex){
                 ActualIndex++;
                 //vytvor pole o 1 vacsie a nakopiruj tam stare zaznami
                 m_JPoint tPHP[] = IncreaseAndCopyArray(PHPoints);
                 Color tC[] = IncreaseAndCopyArray(Colors);
                 PHPoints = new m_JPoint[ActualIndex];
                 PHPoints = tPHP;
                 Colors = new Color[ActualIndex];
                 Colors = tC;
                 int c = GetRand();
                 Colors[ActualIndex - 1] = new Color(0,c,0);
                 PHPoints[ActualIndex - 1] = new m_JPoint(newPHPoint);
            }else{
                ActualIndex=0;
            }
        }
        private m_JPoint[] IncreaseAndCopyArray(m_JPoint[] OldArray) {
            int l = OldArray.length;
            m_JPoint NewArray[]= new m_JPoint[l+1];
            for(int i = 0 ; i < l ; i++ ) {
                    NewArray[i] = new m_JPoint(OldArray[i]);
            }
            return NewArray;
        }
         private Color[] IncreaseAndCopyArray(Color[] OldArray) {
            int l = OldArray.length;
            Color NewArray[]= new Color[l+1];
            for(int i = 0 ; i < l ; i++ ) {
                    NewArray[i] = new Color(OldArray[i].getRGB());
            }
            return NewArray;
        } 
        public m_JPoint GetPoint(int index) {
            return PHPoints[index];
        }
        public Color GetColor(int index) {
            return Colors[index];
        }
        private int GetRand() {
            return 155;
            //return (int)(Math.random()*255D);
        }
    }
    
    
    public m_JVGraph() {
       super();
       EQPoint = new m_JPoint();
       ValuesDefined = false;
       m_lv = new m_JLV();
       
    }

   
   private void drawEQPoint(Graphics g) {
       g.setColor(Color.red);
       int x = (int)coord.GetRX(EQPoint.m_doubleValueX.Get());
       int y = (int)coord.GetRY(EQPoint.m_doubleValueY.Get());
       g.drawLine(0,y,getSize().width,y);
       g.drawLine(x,0,x,getSize().height);
       g.setColor(Color.green);
       g.drawOval(x-3,y-3,5,5);
       g.fillOval(x-3, y-3, 6,6);
   }   
   
   public void SetEQPoint(double x,double y) {
       EQPoint.Set(x,y);
       System.out.println("EQ "+EQPoint.m_doubleValueX.Get()+","+EQPoint.m_doubleValueY.Get());
      
   }
   public void SetParams(double av, double bv, double cv, double dv ) {
        p=new double[4]; 
        p[0]=av;
        p[1]=bv;
        p[2]=cv;
        p[3]=dv;
   }
   
   private void DrawVectorField(Graphics g) {
        
        m_lv.SetParams(p[0], p[1], p[2], p[3]);
        double length = 0.1300000000000000002D;
        double x_step = 15*coord.GetRange().m_doubleValueX.Get() / (double)coord.GetWidth();
        double y_step = 15*coord.GetRange().m_doubleValueY.Get() / (double)coord.GetHeight();
        for(double x = coord.GetMinX(); x < coord.GetMaxX()+5; x += x_step)
        {
            for(double y = coord.GetMinY(); y < coord.GetMaxY()+5; y += y_step)
            {
                double K = m_lv.f(0.0D, x, y);
                double D = m_lv.g(0.0D, x, y);
                double angle = Math.atan(D/K);
                double angle2 = Math.atan(D);
                double dx1 = length * Math.cos(angle);
                double dy1 = length * Math.sin(angle);
                g.setColor(Color.black);
                g.drawLine((int)coord.GetRX(x - dx1), (int)coord.GetRY(y - dy1), (int)coord.GetRX(x + dx1), (int)coord.GetRY(y + dy1));
              }

        }

   }
   private void DrawPhaseLine(Graphics g) {
       int xx1,xx2,yy1,yy2;
           xx1=xx2=yy1=yy2=0;
      
            //draw older graphs
       if (PHPointsArray != null)
            for (int i = 0; i < PHPointsArray.ActualIndex; i++)
            {
                m_lv.SetParams(p);
                m_lv.setH(0.1D);
                double K=PHPointsArray.GetPoint(i).m_doubleValueX.Get();
                double P=PHPointsArray.GetPoint(i).m_doubleValueY.Get();
                for(int c = 1; c < coord.GetWidth(); c++ ) {
                    double values[] = m_lv.Fn(c, K, P );
                    g.setColor(PHPointsArray.GetColor(i));
                   /// g.setColor(Color.cyan);
                    xx1=(int)coord.GetRX(K);
                    xx2=(int)coord.GetRX(values[1]);
                    yy1=(int)coord.GetRY(P);
                    yy2=(int)coord.GetRY(values[2]);

                    g.drawLine(xx1,yy1,xx2,yy2);
                    K=values[1];
                    P=values[2];
                }
           }
       
       for(int t = 1 ; t < Counter; t+=1){
              xx1 = (int)coord.GetRX(y1[t-1]);
              xx2 = (int)coord.GetRX(y1[t]);
              yy1 = (int)coord.GetRY(y2[t-1]);
              yy2 = (int)coord.GetRY(y2[t]);
              g.setColor(Color.blue);
              g.drawLine(xx1,yy1,xx2,yy2);
    }
        int xp[]=new int[]{xx2-4,xx2,xx2-4,xx2,xx2-4,xx2-4};
        int yp[]=new int[]{yy2-4,yy2,yy2+4,yy2,yy2-4,yy2+4};
        g.setColor(Color.red);
        g.drawPolygon(xp,yp,6);       
        
        
   }
   
   Graphics Draw(Graphics offScreenGraphics) {
      if(EQPoint.m_Defined)
           drawEQPoint(offScreenGraphics);
      
      if(ValuesDefined){
           DrawVectorField(offScreenGraphics);
           DrawPhaseLine(offScreenGraphics);
           if(!this.IsPaused()) {
                if ( Counter < (coord.GetWidth() * 10)- 50) {
                    Counter+=5;
                }else{
                    Counter=1;
                }
           }
       }
       return offScreenGraphics;
  }
            //musime prepisat na nase vstupy nase paramtre
   public void SetInputValues(double mi[][], double xV[],double y1V[],double y2V[]){
            //nastavime si pomer podl velkosti
        if(mi != null){
            m=mi;
            double xm[]={coord.GetMinX(),coord.GetMaxX()};
            double ym[]={coord.GetMinY(),coord.GetMaxY()};
            //min x
            if (xm[0] > m[0][0]) xm[0] = mi[0][0];
            //max x
            if (xm[1] < m[1][0]) xm[1] = mi[1][0]+5D;
            else
            if ( (xm[1] - 5D*mi[1][0]) > mi[1][0]) xm[1] = mi[1][0]+5D;
            //mib y
            if (ym[0] > Math.min(mi[0][1],mi[0][2])) ym[0] = Math.min(mi[0][1],m[0][2]);
            
            //max y
            if (ym[1] < mi[1][2]) ym[1] = mi[1][2]+5D;
            else
            if ( (ym[1] - 5D*mi[1][2]) > mi[1][2] ) ym[1] = mi[1][2]+5D;
            //if (ym[1] < Math.max(mi[1][1],mi[1][2])) ym[1] = Math.max(mi[1][1],mi[1][2])+5D;
            //else
            //if ( (ym[1] - 5D*Math.max(mi[1][1],mi[1][2])) > Math.max(mi[1][1],mi[1][2]) ) ym[1] = Math.max(mi[1][1],mi[1][2])+5D;
            coord.SetRange(xm[0],xm[1],ym[0],ym[1]);
            x=xV;
            y1=y1V;
            y2=y2V;
               //nastavime flag vykreslenia
            ValuesDefined = true;
            needToRepaint = true;
       }
   }
   
   
  
   public void AddStartCondition(m_JPoint newPHPoint){
            if (PHPointsArray == null ) {
                PHPointsArray = new CPHPointsArray();
                PHPointsArray.AddStartConditions(newPHPoint);
            }else {
                PHPointsArray.AddStartConditions(newPHPoint);
            }   
   }
   public void DisableMultiGraphs() {
            PHPointsArray = null;
   }
   
  
  
}